POJ 3468 线段树区间求和

线段树区间求和树节点不能只存和,只存和,会导致每次加数的时候都要更新到叶子节点,速度太慢(O(nlogn))。所以我们要存两个量,一个是原来的和nSum,一个是累加的增量Inc。

在增加时,如果要加的区间正好覆盖一个节点,则增加其节点的Inc值,不再往下走,否则要更新nSum(加上本次增量),再将增量往下传,这样更新的复杂度就是O(log(n))。

在查询时,如果待查区间不是正好覆盖一个节点,就将节点的Inc往下带,然后将Inc清0,接下来再往下查询。 Inc往下带的过程也是区间分解的过程,复杂度也是O(log(n))。                                                                                                                                                   

                                                                                   A Simple Problem with Integers

Time Limit: 5000MS   Memory Limit: 131072K
Total Submissions: 79334   Accepted: 24455
Case Time Limit: 2000MS

Description

You have N integers, A1A2, ... , AN. You need to deal with two kinds of operations. One type of operation is to add some given number to each number in a given interval. The other is to ask for the sum of numbers in a given interval.

Input

The first line contains two numbers N and Q. 1 ≤ N,Q ≤ 100000.
The second line contains N numbers, the initial values of A1A2, ... , AN. -1000000000 ≤ Ai ≤ 1000000000.
Each of the next Q lines represents an operation.
"C a b c" means adding c to each of AaAa+1, ... , Ab. -10000 ≤ c ≤ 10000.
"Q a b" means querying the sum of AaAa+1, ... , Ab.

Output

You need to answer all Q commands in order. One answer in a line.

Sample Input

10 5
1 2 3 4 5 6 7 8 9 10
Q 4 4
Q 1 10
Q 2 4
C 3 6 3
Q 2 4

Sample Output

4
55
9
15

  1 #include <iostream>
  2 #include<cstdio>
  3 using namespace std;
  4 struct CNode
  5 {
  6     int L ,R;
  7     CNode * pLeft, * pRight;
  8     long long nSum; //原来的和
  9     long long Inc; //增量c的累加
 10 };
 11 CNode Tree[200010]; // 2倍叶子节点数目就够
 12 int nCount = 0;
 13 int Mid( CNode * pRoot)
 14 {
 15     return (pRoot->L + pRoot->R)/2;
 16 }
 17 void BuildTree(CNode * pRoot,int L, int R)
 18 {
 19     pRoot->L = L;
 20     pRoot->R = R;
 21     pRoot->nSum = 0;
 22     pRoot->Inc = 0;
 23     if( L == R)
 24         return;
 25     nCount ++;
 26     pRoot->pLeft = Tree + nCount;
 27     nCount ++;
 28     pRoot->pRight = Tree + nCount;
 29     BuildTree(pRoot->pLeft,L,(L+R)/2);
 30     BuildTree(pRoot->pRight,(L+R)/2+1,R);
 31 }
 32 void Insert( CNode * pRoot,int i, int v)
 33 {
 34     if( pRoot->L == i && pRoot->R == i)
 35     {
 36         pRoot->nSum = v;
 37         return ;
 38     }
 39     pRoot->nSum += v;
 40     if( i <= Mid(pRoot))
 41         Insert(pRoot->pLeft,i,v);
 42     else
 43         Insert(pRoot->pRight,i,v);
 44 }
 45 void Add( CNode * pRoot, int a, int b, long long c)
 46 {
 47     if( pRoot->L == a && pRoot->R == b)
 48     {
 49         pRoot->Inc += c;
 50         return ;
 51     }
 52     pRoot->nSum += c * ( b - a + 1) ;
 53     if( b <= (pRoot->L + pRoot->R)/2)
 54         Add(pRoot->pLeft,a,b,c);
 55     else if( a >= (pRoot->L + pRoot->R)/2 +1)
 56         Add(pRoot->pRight,a,b,c);
 57     else
 58     {
 59         Add(pRoot->pLeft,a,
 60             (pRoot->L + pRoot->R)/2 ,c);
 61         Add(pRoot->pRight,
 62             (pRoot->L + pRoot->R)/2 + 1,b,c);
 63     }
 64 }
 65 long long QuerynSum( CNode * pRoot, int a, int b)
 66 {
 67     if( pRoot->L == a && pRoot->R == b)
 68         return pRoot->nSum +
 69                (pRoot->R - pRoot->L + 1) * pRoot->Inc ;
 70     pRoot->nSum += (pRoot->R - pRoot->L + 1) * pRoot->Inc ;
 71     Add( pRoot->pLeft,pRoot->L,Mid(pRoot),pRoot->Inc);
 72     Add( pRoot->pRight,Mid(pRoot) + 1,pRoot->R,pRoot->Inc);
 73     pRoot->Inc = 0;
 74     if( b <= Mid(pRoot))
 75         return QuerynSum(pRoot->pLeft,a,b);
 76     else if( a >= Mid(pRoot) + 1)
 77         return QuerynSum(pRoot->pRight,a,b);
 78     else
 79     {
 80         return QuerynSum(pRoot->pLeft,a,Mid(pRoot)) +
 81                QuerynSum(pRoot->pRight,Mid(pRoot) + 1,b);
 82     }
 83 }
 84 int main()
 85 {
 86     int n,q,a,b,c;
 87     char cmd[10];
 88     scanf("%d%d",&n,&q);
 89     int i,j,k;
 90     nCount = 0;
 91     BuildTree(Tree,1,n);
 92     for( i = 1; i <= n; i ++ )
 93     {
 94         scanf("%d",&a);
 95         Insert(Tree,i,a);
 96     }
 97     for( i = 0; i < q; i ++ )
 98     {
 99         scanf("%s",cmd);
100         if ( cmd[0] == ‘C‘ )
101         {
102             scanf("%d%d%d",&a,&b,&c);
103             Add( Tree,a,b,c);
104         }
105         else
106         {
107             scanf("%d%d",&a,&b);
108             printf("%I64d\n",QuerynSum(Tree,a,b));
109         }
110     }
111     return 0;
112 }

时间: 2024-10-19 09:16:21

POJ 3468 线段树区间求和的相关文章

POJ - 3468 线段树区间修改,区间求和

由于是区间求和,因此我们在更新某个节点的时候,需要往上更新节点信息,也就有了tree[root].val=tree[L(root)].val+tree[R(root)].val; 但是我们为了把懒标记打上,当节点表示的区间是完全被询问区间包含,那么这个区间的信息都是有用的,因此我们其实只需要把这个节点更新,并打上懒标记即可.如果以后update 或者 query 需要跑到下面,直接往下pushdown即可. pushdown的时候,由于当前层的信息已经更新,我们需要把信息往下推,并把子节点的信息

hdu 1698+poj 3468 (线段树 区间更新)

http://acm.hdu.edu.cn/showproblem.php?pid=1698 这个题意翻译起来有点猥琐啊,还是和谐一点吧 和涂颜色差不多,区间初始都为1,然后操作都是将x到y改为z,注意 是改为z,不是加或减,最后输出区间总值 也是线段树加lazy操作 1 #include<cstdio> 2 using namespace std; 3 struct point { 4 int l,r; 5 int val,sum; 6 }; 7 point tree[400007]; 8

POJ 3468 (线段树 区间增减) A Simple Problem with Integers

这题WA了好久,一直以为是lld和I64d的问题,后来发现是自己的pushdown函数写错了,说到底还是因为自己对线段树理解得不好. 因为是懒惰标记,所以只有在区间分开的时候才会将标记往下传递.更新和查询都要pushdown. 1 #include <cstdio> 2 3 typedef long long LL; 4 5 const int maxn = 100000 + 10; 6 7 int n, m, qL, qR, v; 8 LL sum[maxn << 2], add

A Simple Problem with Integers POJ - 3468 线段树区间修改+区间查询

//add,懒标记,给以当前节点为根的子树中的每一个点加上add(不包含根节点) // #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> using namespace std; typedef long long LL; const int N = 100010; int n, m; int w[N]; struct Node { int l, r;

线段树 区间求和 poj 3468 A Simple Problem with Integers

题意: 给n个整数,求两种操作:1.给一个区间的数都加上一个数 2.查询一个区间的数的和  ,输出每次查询的结果 线段树区间求和,注意点: 1.使用lazy操作pushdown的时候,应该是子节点的lazy值加上父节点的lazy值,而不是直接赋值成父节点的lazy值,因为子节点可能之前也被操作过 2.节点的sum求和的时候应该加上区间的和(虽然直接加上修改值也能过样例TAT) 3.sum应该用long long 代码: #include <cstdlib> #include <cctyp

POJ 2823 Sliding Window 线段树区间求和问题

题目链接 线段树区间求和问题,维护一个最大值一个最小值即可,线段树要用C++交才能过. 注意这道题不是求三个数的最大值最小值,是求k个的. 还有一种做法是单调队列,耗时更少. #include <iostream> #include <cstdio> #include <cmath> #include <cstring> #include <algorithm> #define N 1000005 using namespace std; int

HDU4027 Can you answer these queries 线段树区间求和+剪枝

给了你n,然后n个数字在一个数组中,接下来m个询问,每个询问三个数字 t,x,y,若t==0,那么修改区间[x,y]的每一个值,变为原来每个位置上的数 开根号取整,若t==1,那么对区间[x,y]求和 由于n,m,很大,所以树状数组铁定超时,若直接用线段树来做区间修改,那么也是超时,这类题目没别的方法了,静心剪枝,发现题目给的数据范围为2^63,有没有发现,2^63开根号 绝对不需要开10次,就能到1,到1以后就不需要再开了,意思就是若有某个区间[x,y]每一个点的值都为1时,这一段区间事实上是

HDU 4027 Can you answer these queries? (线段树区间求和)

Can you answer these queries? Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65768/65768 K (Java/Others)Total Submission(s): 12290    Accepted Submission(s): 2912 Problem Description A lot of battleships of evil are arranged in a line before

POJ 3468 线段树+lazy标记

lazy标记 Time Limit:5000MS     Memory Limit:131072KB     64bit IO Format:%I64d & %I64u Submit Status Description You have N integers, A1, A2, ... , AN. You need to deal with two kinds of operations. One type of operation is to add some given number to